// #autoload
// #name = UberTimeHUD
// #version = 1.1.2
// #date = August 17, 2002
// #author = Paul Tousignant
// #warrior = UberGuy (FT)
// #email = uberguy@tribalwar.com
// #web = http://scripts.tribalwar.com/uberguy
// #description = Show the real clock time in a HUD.
// #category = UberGuy's Scripts
// #status = Release
// #readme = scripts/UberGuy/UberTimeHUD.txt
// #config = UberTimeGUI
// #credit = TwoStep, for his nifty time script, now no longer needed :D

if ($pref::UberTimeHud::24Hour   $= "") $pref::UberTimeHud::24Hour   = false;
if ($pref::UberTimeHud::showSecs $= "") $pref::UberTimeHud::showSecs = true;
if ($pref::UberTimeHud::showAMPM $= "") $pref::UberTimeHud::showAMPM = true;
if ($pref::UberTimeHud::xparent  $= "") $pref::UberTimeHud::xparent  = true;

function makeUberTimeHud() {

	if (!isObject(UberTimeHud)) {

		new GuiControlProfile ("UberTimeHudLabelProfile")
		{
			fontType = "Univers Condensed";
			fontSize = 16;
			fontColor = "255 255 64";
			justify = "left";
		};
		new GuiControlProfile ("UberTimeHudTextProfile")
		{
			fontType = "Univers Condensed";
			fontSize = 16;
			fontColor = "255 255 255";
			justify = "left";
		};
		new ShellFieldCtrl(UberTimeHud)
		{
			profile = $pref::UberTimeHud::xparent ? GuiConsoleProfile : GuiChatBackProfile;
			horizSizing = "left";
			vertSizing = "bottom";
			position = "0 0";
			extent = "95 16";
			minExtent = "8 8";
			visible = "1";

			new GuiTextCtrl()
			{
				profile = "UberTimeHudLabelProfile";
				horizSizing = "right";
				vertSizing = "bottom";
				position = "4 0";
				extent = "25 16 ";
				visible = "1";
				text = "Time:";
			};

			new GuiTextCtrl(UberTimeHudTime) {
				profile = "UberTimeHudTextProfile";
				horizSizing = "right";
				vertSizing = "bottom";
				position = "30 0";
				extent = "65 16 ";
				visible = "1";
			};
		};

		UberTimeHud.updateUberTimeHud();
	}
}

function UberTimeHud::reset(%this) {

	%this.profile =	$pref::UberTimeHud::xparent ? GuiConsoleProfile : GuiChatBackProfile;
	if(playGui.isMember(UberTimeHud)) playGui.remove(%this);
	playGui.add(%this);
}

function UberTimeHud::calcFormatString(%this) {

	if ($pref::UberTimeHud::24Hour) {
		%fmt = "HH:nn";
		if ($pref::UberTimeHud::showSecs) %fmt = %fmt @ ":ss";
	}
	else {
		%fmt = "hh:nn";
		if ($pref::UberTimeHud::showSecs) %fmt = %fmt @ ":ss";
		if ($pref::UberTimeHud::showAMPM) %fmt = %fmt @ " A";
	}
	%this.format = %fmt;
}


function UberTimeHud::updateUberTimeHud(%this) {

	if (isEventPending(%this.schedID)) cancel(%this.schedID);
	UberTimeHudTime.setText(formatTimeString(%this.format));
	%this.schedID = %this.schedule(1000,updateUberTimeHud);
}

package uberTimeHudPkg {

	function LoadingGui::onWake(%this) {

		parent::onWake(%this);

		if (!UberTimeHud.setup) {
			if (isObject(HM) && isObject(HudMover))
				hudmover::addhud(UberTimeHud, "UberTimeHUD");
		}
		if (!playGui.isMember(uberTimeHud)) playGui.add(uberTimeHud);
		UberTimeHud.setup = true;
	}

	function PlayGui::onWake(%this) {

		parent::onWake(%this);
		UberTimeHud.calcFormatString();
	}

	function clientCmdTogglePlayHuds(%val) {

		parent::clientCmdTogglePlayHuds(%val);
		UberTimeHud.setVisible(%val);
	}
};
activatePackage(uberTimeHudPkg);

if (!isObject(UberTimeGUI)) {

	new GuiControl(UberTimeGUI) {
		profile = "GuiDefaultProfile";
		horizSizing = "center";
		vertSizing = "center";
		position = "0 21";
		extent = "400 310";
		minExtent = "400 310";
		visible = "1";
		hideCursor = "0";
		bypassHideCursor = "0";
		helpTag = "0";

		new ShellFieldCtrl() {
			profile = "ShellFieldProfile";
			horizSizing = "right";
			vertSizing = "bottom";
			position = "77 41";
			extent = "244 220";
			minExtent = "16 18";
			visible = "1";
			hideCursor = "0";
			bypassHideCursor = "0";
			helpTag = "0";

			new GuiTextCtrl() {
				profile = "DebriefHeadlineTextProfile";
				horizSizing = "right";
				vertSizing = "bottom";
				position = "38 27";
				extent = "179 32";
				minExtent = "8 8";
				visible = "1";
				hideCursor = "0";
				bypassHideCursor = "0";
				helpTag = "0";
				text = "UberTimeHUD Options";
				longTextBuffer = "0";
				maxLength = "255";
			};
			new ShellToggleButton(UberTime2hHr) {
				profile = "ShellRadioProfile";
				horizSizing = "right";
				vertSizing = "bottom";
				position = "67 73";
				extent = "106 30";
				minExtent = "26 27";
				visible = "1";
				hideCursor = "0";
				bypassHideCursor = "0";
				variable = "$pref::UberTimeHud::24Hour";
				helpTag = "0";
				text = "24-hour display";
				longTextBuffer = "0";
				maxLength = "255";
			};
			new ShellToggleButton(UberTimeAMPM) {
				profile = "ShellRadioProfile";
				horizSizing = "right";
				vertSizing = "bottom";
				position = "67 93";
				extent = "106 30";
				minExtent = "26 27";
				visible = "1";
				hideCursor = "0";
				bypassHideCursor = "0";
				variable = "$pref::UberTimeHud::showSecs";
				helpTag = "0";
				text = "Show Seconds";
				longTextBuffer = "0";
				maxLength = "255";
			};
			new ShellToggleButton(UberTimeXparent) {
				profile = "ShellRadioProfile";
				horizSizing = "right";
				vertSizing = "bottom";
				position = "67 133";
				extent = "106 30";
				minExtent = "26 27";
				visible = "1";
				hideCursor = "0";
				bypassHideCursor = "0";
				variable = "$pref::UberTimeHud::xparent";
				command = "UberTimeHud.reset();";
				helpTag = "0";
				text = "Transparent HUD";
				longTextBuffer = "0";
				maxLength = "255";
			};
			new ShellToggleButton(UberTimeShowSecs) {
				profile = "ShellRadioProfile";
				horizSizing = "right";
				vertSizing = "bottom";
				position = "67 113";
				extent = "106 30";
				minExtent = "26 27";
				visible = "1";
				hideCursor = "0";
				bypassHideCursor = "0";
				variable = "$pref::UberTimeHud::showAMPM";
				helpTag = "0";
				text = "Show \"AM/PM\"";
				longTextBuffer = "0";
				maxLength = "255";
			};
		};
	};
}

function UberTimeGUI::onWake(%this) {
	// null
}

makeUberTimeHud();